''*******************************
''* TIME.spin v1.0       6/2016 *
''* Author: Werner L. Schneider *
''*******************************
''
''
VAR

    long cog                     ' cog flag/id

    'DO NOT REARRANGE LONGS
    long count1                  ' 4 contiguous longs
    long count2
    long count3
    long flag


PUB start
    stop

    count1 := 0
    count2 := 0
    count3 := 0
    flag := 0
    cog := cognew(@entry, @count1) + 1


PUB stop
    if cog
        cogstop(cog~ - 1)
    longfill(@count1, 0, 4)


PUB set1

    flag := 1


PUB set2

    flag := 2


PUB end

    flag := 0


PUB get1 : count    

    count := count1


PUB get2 : count    

    count := count2


PUB get3 : count    

    count := count3


DAT

'***********************************
'* Assembly language "time" driver *
'***********************************

                        org     
'
' Entry
'
entry                   mov       t1, PAR
                        mov       _count1, t1             ' get count1_ptr  

                        add       t1, #4                  
                        mov       _count2, t1             ' get count2_ptr  

                        add       t1, #4                  
                        mov       _count3, t1             ' get count3_ptr  

                        add       t1, #4                  
                        mov       _flag,   t1            ' get flag_ptr  

                        mov       _pd, pdelay

bigloop                 rdlong    t1, _flag        wz
'             if_z       jmp       #waitflag     
                        and       t1, #1           wz, nr
             if_nz      jmp       #c1_seq
                        and       t1, #2           wz, nr
             if_nz      jmp       #c2_seq
incr3                   rdlong    t1, _count3
                        add       t1, #1
                        wrlong    t1, _count3
                        mov       _delay, cnt          
                        add       _delay, _pd
                        waitcnt   _delay, _pd
                        jmp       #bigloop


c1_seq                  rdlong    t1, _count1
                        add       t1, #1
                        wrlong    t1, _count1
                        jmp       #incr3


c2_seq                  rdlong    t1, _count2
                        add       t1, #1
                        wrlong    t1, _count2
                        jmp       #incr3


'*********************************************************************************************************

                        ' Data

pdelay                  long      80_000_000 


'
' Uninitialized data
'
t1                      res       1

_delay                  res       1
_pd                     res       1

_count1                 res       1               ' 3 params                 
_count2                 res       1
_count3                 res       1
_flag                   res       1


                        fit     $1f0
